
clear all; close all; clc
y = zeros(1,120);                           %urceni poctu mereni(casu)
s1 = serial('COM4');                            
s1.BaudRate=9600;                           %musi byt v souladu s Arduino    
     
%otevreni portu
fopen(s1);
clear data

for i= 1:120                                %120 mereni korespondence s y
    data=fscanf(s1);                        %precteni dat ze senzoru
    y(i) = str2double(data);                %prevod ze string na ciselne hodnoty
    h0=figure(1)
    h1=uicontrol('Units','Normalized','Position',[0,0.8,0.1,0.1],'Style','Text',...
    'String',y(i),'Fontsize',30)
    h2=plot(i,y(i),'+r')
    title('Aktualni vzdalenost');
    xlabel('cas (s)');
    ylabel('vzdalenost (mm)');
    drawnow;
    hold on
end

% zavreni portu
fclose(s1);  



%odfiltrovani extremne vysokych hodnot, u kterych je pravdepodobnost chyby
a=filtr(y);

%urceni intervalu, na kterem chceme vykreslit data
x=1:length(y);

%vykresleni dat v grafech, vlevo normalni, vpravo spline
figure(2)

subplot(1,2,1)
maximum1=max(a);
plot(x,a,'r')
axis([0,125,0,maximum1+100])
grid on
title('spojeni primkami');
xlabel('cas (s)');
ylabel('vzdalenost (mm)');

subplot(1,2,2)
xx=1:.25:120;
yy=spline(x,a,xx);
maximum2=max(yy);
plot(xx,yy,'r')
axis([0,125,0,maximum2+100])
grid on
title('prolozeni splinem');
xlabel('cas (s)');
ylabel('vzdalenost (mm)');


